The Data panel organises the available data and shows how it is structured across sources.
AG Studio supports multiple data sources. This page explains how data is presented in the Data panel and how it is structured across sources. For how fields behave when used in widgets, see Using Data.
Data Panel Copy Link
The Data Panel lists the data available to the report, grouped by source. For an overview of how the Data Panel fits within the Studio interface, see User Interface.
The Data panel can be used to search for items by name. When a data pill is dragged, valid drop areas are highlighted in blue. Data pills can be dropped into widget configuration slots and Filter Conditions.
Select any data item to switch the Edit Panel to its data-field view, which displays metadata about that item.
Data Items Copy Link
Data items are fields made available in the Data Panel. A field is a data element that can be used in widgets and is one of three types: a column, a calculated column, or a measure.
- Columns are fields that come directly from the underlying data source and are typically used for categories (grouping) and, where appropriate, as values.
- Calculated Columns are fields derived from other data that return a value for each row.
- Measures are pre-aggregated calculations intended for Metrics and KPIs.
Each data item has the following properties:
| Property | Description |
|---|---|
| Id | The unique identifier for the data item. |
| Name | The display name shown in the interface. |
| Description | Additional supporting information about the data item. |
| Data Type | The type of data the item contains, such as text, number, date, or boolean. |
| Calculation Type | Whether the field is calculated: No Calculation for a column from the source, Calculation for a Calculated Column, or Measure for a Measure. |
| Format | How the value is displayed in the interface, for example as text, currency, percentage, or a date format. |
Select any field in the Data Panel to open its data-field view, which shows the metadata for that field, including its name, description, data type, calculation type, and format.
Id, Name, and Data Type are required and configured by your developer. Description and Format are optional and also configured by your developer.
Calculation Type reports which of the three kinds of field it is, and that is chosen when the field is created rather than worked out from the data. A field that comes from a data source is always a column, so it shows No Calculation. A calculation is either a Calculated Column or a Measure, and whoever creates it chooses which: your developer for the calculations you are given, you for the ones you add yourself (see Calculations).
The choice decides how the field can be used. A column or a Calculated Column holds a value for each row, so when you use one as a value in a widget you choose how to aggregate it. A Measure is already aggregated, so it brings its own aggregation and no other can be applied to it. See Using Data.
import {
AgFieldDefinition,
AgReportState,
AgStudioApi,
AgStudioProperties,
createStudio,
enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const salesFields: AgFieldDefinition[] = [
{
id: "sale_id",
name: "Sale ID",
format: "textFormat",
description: "Unique identifier for each sale transaction",
},
{
id: "date",
name: "Date",
format: "dateFormat",
description: "Date when the sale occurred",
},
{
id: "store_id",
name: "Store ID",
format: "textFormat",
description: "Identifier for the store where the sale took place",
},
{
id: "product_id",
name: "Product ID",
format: "textFormat",
description: "Identifier for the product sold",
},
{
id: "customer_id",
name: "Customer ID",
format: "textFormat",
description: "Identifier for the customer making the purchase",
},
{
id: "employee_id",
name: "Employee ID",
format: "textFormat",
description: "Identifier for the employee who processed the sale",
},
{
id: "quantity",
name: "Quantity",
format: "integerFormat",
description: "Number of units sold",
},
{
id: "unit_price",
name: "Unit Price",
format: "currencyFormat",
description: "Price per unit of the product",
formatOptions: {
format: "$#,##0.00",
},
},
{
id: "discount_pct",
name: "Discount Percentage",
format: "percentageFormat",
description: "Discount applied to the sale as a percentage",
formatOptions: {
format: "0.00%",
},
},
{
id: "amount",
name: "Amount",
format: "currencyFormat",
description: "Total sale amount after discounts",
formatOptions: {
format: "$#,##0.00",
},
},
{
id: "payment_method",
name: "Payment Method",
format: "textFormat",
description: "Method used for payment",
},
{
id: "status",
name: "Status",
format: "textFormat",
description: "Current status of the sale transaction",
},
{
id: "promo_id",
name: "Promo ID",
format: "textFormat",
description: "Identifier for any promotional offer applied",
},
];
const initialState: AgReportState = {
pages: [
{
id: "a",
},
],
selectedPageId: "a",
};
const studioProperties: AgStudioProperties = {
mode: "edit",
initialState,
panels: {
edit: {
right: ["edit", "data"],
},
},
data: {
sources: [
{
id: "sales",
name: "Sales",
fields: salesFields,
data: getData(),
},
],
},
};
let studioApi: AgStudioApi;
// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
Data Source Copy Link
Data items shown in the Data Panel are grouped by data source. Reports can be powered by one data source or multiple data sources.
When the report uses a single data source, all fields and calculations come from the same source. Widgets can be configured without thinking about relationships.
When multiple data sources are used, every data item is listed under the source it comes from. A calculation is listed under a single source as well, even when its expression reads from more than one. A calculation you create stays in the section you created it in, whatever its expression later references. A calculation your developer provides is listed under the first source its expression reaches, whether it names that source itself or reaches it through another calculation it references. One that reaches no source at all is listed in a Computed Columns section at the end of the panel.
If relationships exist between data sources, data items can be combined across sources when Configuring Widgets. If no relationship exists between selected data, the interface prevents invalid combinations.
When you use data from multiple sources, you can create widgets that combine data items from different sources. In the example below, the table widget displays product names from the Products table along with order metrics from the Order Items table, including quantity, unit price, and net sales.
import {
AgReportState,
AgStudioApi,
AgStudioProperties,
createStudio,
enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const initialState: AgReportState = {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "products.product_name" },
{ id: "order_items.quantity", aggregation: "sum" },
{ id: "order_items.unit_price", aggregation: "avg" },
{ id: "net_sales" },
],
},
format: {
title: {
enabled: true,
text: "Sales by Product",
},
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 32,
},
},
},
],
selectedPageId: "page1",
};
const studioProperties: AgStudioProperties = {
mode: "edit",
initialState,
panels: {
edit: {
right: ["edit", "data"],
},
},
data: getMainDemoData("https://www.ag-grid.com/studio/example-assets"),
};
let studioApi: AgStudioApi;
// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);
Calculated Fields Copy Link
Some fields in the Data panel are calculations rather than raw source columns. Calculations are derived from other fields, and are either provided by your developer or created by you (see Calculations). They are computed at runtime rather than stored in the underlying data, so they update as the data changes. There are two types of calculations:
Calculated Columns - Non-aggregated calculations that return a value for each row. They are useful for transforming data (for example, cleaned labels), bucketing values (for example, a band), or computing flags based on logic.
Measures - Pre-aggregated calculations that compute values at the dataset level or per category. When a Measure is used without any grouping categories, it returns a single aggregated value for the entire dataset (for example, total revenue across all regions). When used with categories, it returns one value per category (for example, total revenue per region). Measures are intended for Metrics and KPIs and do not support changing aggregation at runtime.
Both are derived from other fields and computed at runtime. The difference is whether the value arrives already aggregated. A Calculated Column does not, so it behaves like any other column in a widget and you choose how to aggregate it. A Measure does, so it carries its own aggregation and none can be applied on top.
| Icon | Description |
|---|---|
| Number data types | |
| Calculated number data type |
In the example below, the table demonstrates a measure grouped by product. Line Net (sum) is an aggregated column calculated from order items. Gross Margin % is a measure that shows the aggregated margin percentage for each product.
import {
AgReportState,
AgStudioApi,
AgStudioProperties,
createStudio,
enableStudioDevValidations,
} from "ag-studio";
import { getCalculationsData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const initialState: AgReportState = {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "products.product_name" },
{ id: "line_net", aggregation: "sum" },
{ id: "gross_margin_pct" },
],
},
format: {
title: {
enabled: true,
text: "Calculated Column and Measure by Product",
},
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 32,
},
},
},
],
selectedPageId: "page1",
};
const studioProperties: AgStudioProperties = {
mode: "edit",
initialState,
panels: {
edit: {
right: ["edit", "data"],
},
},
data: getCalculationsData("https://www.ag-grid.com/studio/example-assets"),
};
let studioApi: AgStudioApi;
// setup Studio after the page has finished loading
const studioDiv = document.querySelector<HTMLElement>("#myStudio")!;
studioApi = createStudio(studioDiv, studioProperties);

The Data panel organises the available data and shows how it is structured across sources.
AG Studio supports multiple data sources. This page explains how data is presented in the Data panel and how it is structured across sources. For how fields behave when used in widgets, see Using Data.
Data Panel Copy Link
The Data Panel lists the data available to the report, grouped by source. For an overview of how the Data Panel fits within the Studio interface, see User Interface.
The Data panel can be used to search for items by name. When a data pill is dragged, valid drop areas are highlighted in blue. Data pills can be dropped into widget configuration slots and Filter Conditions.
Select any data item to switch the Edit Panel to its data-field view, which displays metadata about that item.
Data Items Copy Link
Data items are fields made available in the Data Panel. A field is a data element that can be used in widgets and is one of three types: a column, a calculated column, or a measure.
- Columns are fields that come directly from the underlying data source and are typically used for categories (grouping) and, where appropriate, as values.
- Calculated Columns are fields derived from other data that return a value for each row.
- Measures are pre-aggregated calculations intended for Metrics and KPIs.
Each data item has the following properties:
| Property | Description |
|---|---|
| Id | The unique identifier for the data item. |
| Name | The display name shown in the interface. |
| Description | Additional supporting information about the data item. |
| Data Type | The type of data the item contains, such as text, number, date, or boolean. |
| Calculation Type | Whether the field is calculated: No Calculation for a column from the source, Calculation for a Calculated Column, or Measure for a Measure. |
| Format | How the value is displayed in the interface, for example as text, currency, percentage, or a date format. |
Select any field in the Data Panel to open its data-field view, which shows the metadata for that field, including its name, description, data type, calculation type, and format.
Id, Name, and Data Type are required and configured by your developer. Description and Format are optional and also configured by your developer.
Calculation Type reports which of the three kinds of field it is, and that is chosen when the field is created rather than worked out from the data. A field that comes from a data source is always a column, so it shows No Calculation. A calculation is either a Calculated Column or a Measure, and whoever creates it chooses which: your developer for the calculations you are given, you for the ones you add yourself (see Calculations).
The choice decides how the field can be used. A column or a Calculated Column holds a value for each row, so when you use one as a value in a widget you choose how to aggregate it. A Measure is already aggregated, so it brings its own aggregation and no other can be applied to it. See Using Data.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgFieldDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.tsx";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const salesFields: AgFieldDefinition[] = [
{
id: "sale_id",
name: "Sale ID",
format: "textFormat",
description: "Unique identifier for each sale transaction",
},
{
id: "date",
name: "Date",
format: "dateFormat",
description: "Date when the sale occurred",
},
{
id: "store_id",
name: "Store ID",
format: "textFormat",
description: "Identifier for the store where the sale took place",
},
{
id: "product_id",
name: "Product ID",
format: "textFormat",
description: "Identifier for the product sold",
},
{
id: "customer_id",
name: "Customer ID",
format: "textFormat",
description: "Identifier for the customer making the purchase",
},
{
id: "employee_id",
name: "Employee ID",
format: "textFormat",
description: "Identifier for the employee who processed the sale",
},
{
id: "quantity",
name: "Quantity",
format: "integerFormat",
description: "Number of units sold",
},
{
id: "unit_price",
name: "Unit Price",
format: "currencyFormat",
description: "Price per unit of the product",
formatOptions: {
format: "$#,##0.00",
},
},
{
id: "discount_pct",
name: "Discount Percentage",
format: "percentageFormat",
description: "Discount applied to the sale as a percentage",
formatOptions: {
format: "0.00%",
},
},
{
id: "amount",
name: "Amount",
format: "currencyFormat",
description: "Total sale amount after discounts",
formatOptions: {
format: "$#,##0.00",
},
},
{
id: "payment_method",
name: "Payment Method",
format: "textFormat",
description: "Method used for payment",
},
{
id: "status",
name: "Status",
format: "textFormat",
description: "Current status of the sale transaction",
},
{
id: "promo_id",
name: "Promo ID",
format: "textFormat",
description: "Identifier for any promotional offer applied",
},
];
const StudioExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [data, setData] = useState<AgDataSource>({
sources: [
{
id: "sales",
name: "Sales",
fields: salesFields,
data: getData(),
},
],
});
const initialState = useMemo<AgReportState>(() => {
return {
pages: [
{
id: "a",
},
],
selectedPageId: "a",
};
}, []);
const panels = useMemo<AgPanelConfig>(() => {
return {
edit: {
right: ["edit", "data"],
},
};
}, []);
return (
<div style={containerStyle}>
<div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
<AgStudio
style={studioStyle}
className="my-studio-container"
data={data}
initialState={initialState}
mode={"edit"}
panels={panels}
/>
</div>
</div>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<StudioExample />
</StrictMode>,
);
Data Source Copy Link
Data items shown in the Data Panel are grouped by data source. Reports can be powered by one data source or multiple data sources.
When the report uses a single data source, all fields and calculations come from the same source. Widgets can be configured without thinking about relationships.
When multiple data sources are used, every data item is listed under the source it comes from. A calculation is listed under a single source as well, even when its expression reads from more than one. A calculation you create stays in the section you created it in, whatever its expression later references. A calculation your developer provides is listed under the first source its expression reaches, whether it names that source itself or reaches it through another calculation it references. One that reaches no source at all is listed in a Computed Columns section at the end of the panel.
If relationships exist between data sources, data items can be combined across sources when Configuring Widgets. If no relationship exists between selected data, the interface prevents invalid combinations.
When you use data from multiple sources, you can create widgets that combine data items from different sources. In the example below, the table widget displays product names from the Products table along with order metrics from the Order Items table, including quantity, unit price, and net sales.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.tsx";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const StudioExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [data, setData] = useState<AgDataSource>(
getMainDemoData("https://www.ag-grid.com/studio/example-assets"),
);
const initialState = useMemo<AgReportState>(() => {
return {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "products.product_name" },
{ id: "order_items.quantity", aggregation: "sum" },
{ id: "order_items.unit_price", aggregation: "avg" },
{ id: "net_sales" },
],
},
format: {
title: {
enabled: true,
text: "Sales by Product",
},
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 32,
},
},
},
],
selectedPageId: "page1",
};
}, []);
const panels = useMemo<AgPanelConfig>(() => {
return {
edit: {
right: ["edit", "data"],
},
};
}, []);
return (
<div style={containerStyle}>
<div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
<AgStudio
style={studioStyle}
className="my-studio-container"
data={data}
initialState={initialState}
mode={"edit"}
panels={panels}
/>
</div>
</div>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<StudioExample />
</StrictMode>,
);
Calculated Fields Copy Link
Some fields in the Data panel are calculations rather than raw source columns. Calculations are derived from other fields, and are either provided by your developer or created by you (see Calculations). They are computed at runtime rather than stored in the underlying data, so they update as the data changes. There are two types of calculations:
Calculated Columns - Non-aggregated calculations that return a value for each row. They are useful for transforming data (for example, cleaned labels), bucketing values (for example, a band), or computing flags based on logic.
Measures - Pre-aggregated calculations that compute values at the dataset level or per category. When a Measure is used without any grouping categories, it returns a single aggregated value for the entire dataset (for example, total revenue across all regions). When used with categories, it returns one value per category (for example, total revenue per region). Measures are intended for Metrics and KPIs and do not support changing aggregation at runtime.
Both are derived from other fields and computed at runtime. The difference is whether the value arrives already aggregated. A Calculated Column does not, so it behaves like any other column in a widget and you choose how to aggregate it. A Measure does, so it carries its own aggregation and none can be applied on top.
| Icon | Description |
|---|---|
| Number data types | |
| Calculated number data type |
In the example below, the table demonstrates a measure grouped by product. Line Net (sum) is an aggregated column calculated from order items. Gross Margin % is a measure that shows the aggregated margin percentage for each product.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgStudio, AgStudioRef } from "ag-studio-react";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getCalculationsData } from "./data.tsx";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const StudioExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const studioStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [data, setData] = useState<AgDataSource>(
getCalculationsData("https://www.ag-grid.com/studio/example-assets"),
);
const initialState = useMemo<AgReportState>(() => {
return {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "products.product_name" },
{ id: "line_net", aggregation: "sum" },
{ id: "gross_margin_pct" },
],
},
format: {
title: {
enabled: true,
text: "Calculated Column and Measure by Product",
},
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 32,
},
},
},
],
selectedPageId: "page1",
};
}, []);
const panels = useMemo<AgPanelConfig>(() => {
return {
edit: {
right: ["edit", "data"],
},
};
}, []);
return (
<div style={containerStyle}>
<div style={{ display: "flex", flexDirection: "column", height: "100%" }}>
<AgStudio
style={studioStyle}
className="my-studio-container"
data={data}
initialState={initialState}
mode={"edit"}
panels={panels}
/>
</div>
</div>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<StudioExample />
</StrictMode>,
);

The Data panel organises the available data and shows how it is structured across sources.
AG Studio supports multiple data sources. This page explains how data is presented in the Data panel and how it is structured across sources. For how fields behave when used in widgets, see Using Data.
Data Panel Copy Link
The Data Panel lists the data available to the report, grouped by source. For an overview of how the Data Panel fits within the Studio interface, see User Interface.
The Data panel can be used to search for items by name. When a data pill is dragged, valid drop areas are highlighted in blue. Data pills can be dropped into widget configuration slots and Filter Conditions.
Select any data item to switch the Edit Panel to its data-field view, which displays metadata about that item.
Data Items Copy Link
Data items are fields made available in the Data Panel. A field is a data element that can be used in widgets and is one of three types: a column, a calculated column, or a measure.
- Columns are fields that come directly from the underlying data source and are typically used for categories (grouping) and, where appropriate, as values.
- Calculated Columns are fields derived from other data that return a value for each row.
- Measures are pre-aggregated calculations intended for Metrics and KPIs.
Each data item has the following properties:
| Property | Description |
|---|---|
| Id | The unique identifier for the data item. |
| Name | The display name shown in the interface. |
| Description | Additional supporting information about the data item. |
| Data Type | The type of data the item contains, such as text, number, date, or boolean. |
| Calculation Type | Whether the field is calculated: No Calculation for a column from the source, Calculation for a Calculated Column, or Measure for a Measure. |
| Format | How the value is displayed in the interface, for example as text, currency, percentage, or a date format. |
Select any field in the Data Panel to open its data-field view, which shows the metadata for that field, including its name, description, data type, calculation type, and format.
Id, Name, and Data Type are required and configured by your developer. Description and Format are optional and also configured by your developer.
Calculation Type reports which of the three kinds of field it is, and that is chosen when the field is created rather than worked out from the data. A field that comes from a data source is always a column, so it shows No Calculation. A calculation is either a Calculated Column or a Measure, and whoever creates it chooses which: your developer for the calculations you are given, you for the ones you add yourself (see Calculations).
The choice decides how the field can be used. A column or a Calculated Column holds a value for each row, so when you use one as a value in a widget you choose how to aggregate it. A Measure is already aggregated, so it brings its own aggregation and no other can be applied to it. See Using Data.
import { Component } from "@angular/core";
import { AgStudio } from "ag-studio-angular";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgFieldDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgStudio],
template: `<div style="display: flex; flex-direction: column; height: 100%">
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
[initialState]="initialState"
[mode]="mode"
[panels]="panels"
[data]="data"
/>
</div> `,
})
export class AppComponent {
initialState: AgReportState = {
pages: [
{
id: "a",
},
],
selectedPageId: "a",
};
mode: AgStudioMode = "edit";
panels: AgPanelConfig = {
edit: {
right: ["edit", "data"],
},
};
data: AgDataSourcesDefinition | AgDataEngine = {
sources: [
{
id: "sales",
name: "Sales",
fields: salesFields,
data: getData(),
},
],
};
}
const salesFields: AgFieldDefinition[] = [
{
id: "sale_id",
name: "Sale ID",
format: "textFormat",
description: "Unique identifier for each sale transaction",
},
{
id: "date",
name: "Date",
format: "dateFormat",
description: "Date when the sale occurred",
},
{
id: "store_id",
name: "Store ID",
format: "textFormat",
description: "Identifier for the store where the sale took place",
},
{
id: "product_id",
name: "Product ID",
format: "textFormat",
description: "Identifier for the product sold",
},
{
id: "customer_id",
name: "Customer ID",
format: "textFormat",
description: "Identifier for the customer making the purchase",
},
{
id: "employee_id",
name: "Employee ID",
format: "textFormat",
description: "Identifier for the employee who processed the sale",
},
{
id: "quantity",
name: "Quantity",
format: "integerFormat",
description: "Number of units sold",
},
{
id: "unit_price",
name: "Unit Price",
format: "currencyFormat",
description: "Price per unit of the product",
formatOptions: {
format: "$#,##0.00",
},
},
{
id: "discount_pct",
name: "Discount Percentage",
format: "percentageFormat",
description: "Discount applied to the sale as a percentage",
formatOptions: {
format: "0.00%",
},
},
{
id: "amount",
name: "Amount",
format: "currencyFormat",
description: "Total sale amount after discounts",
formatOptions: {
format: "$#,##0.00",
},
},
{
id: "payment_method",
name: "Payment Method",
format: "textFormat",
description: "Method used for payment",
},
{
id: "status",
name: "Status",
format: "textFormat",
description: "Current status of the sale transaction",
},
{
id: "promo_id",
name: "Promo ID",
format: "textFormat",
description: "Identifier for any promotional offer applied",
},
];
Data Source Copy Link
Data items shown in the Data Panel are grouped by data source. Reports can be powered by one data source or multiple data sources.
When the report uses a single data source, all fields and calculations come from the same source. Widgets can be configured without thinking about relationships.
When multiple data sources are used, every data item is listed under the source it comes from. A calculation is listed under a single source as well, even when its expression reads from more than one. A calculation you create stays in the section you created it in, whatever its expression later references. A calculation your developer provides is listed under the first source its expression reaches, whether it names that source itself or reaches it through another calculation it references. One that reaches no source at all is listed in a Computed Columns section at the end of the panel.
If relationships exist between data sources, data items can be combined across sources when Configuring Widgets. If no relationship exists between selected data, the interface prevents invalid combinations.
When you use data from multiple sources, you can create widgets that combine data items from different sources. In the example below, the table widget displays product names from the Products table along with order metrics from the Order Items table, including quantity, unit price, and net sales.
import { Component } from "@angular/core";
import { AgStudio } from "ag-studio-angular";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgStudio],
template: `<div style="display: flex; flex-direction: column; height: 100%">
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
[initialState]="initialState"
[mode]="mode"
[panels]="panels"
[data]="data"
/>
</div> `,
})
export class AppComponent {
initialState: AgReportState = {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "products.product_name" },
{ id: "order_items.quantity", aggregation: "sum" },
{ id: "order_items.unit_price", aggregation: "avg" },
{ id: "net_sales" },
],
},
format: {
title: {
enabled: true,
text: "Sales by Product",
},
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 32,
},
},
},
],
selectedPageId: "page1",
};
mode: AgStudioMode = "edit";
panels: AgPanelConfig = {
edit: {
right: ["edit", "data"],
},
};
data: AgDataSourcesDefinition | AgDataEngine = getMainDemoData(
"https://www.ag-grid.com/studio/example-assets",
);
}
Calculated Fields Copy Link
Some fields in the Data panel are calculations rather than raw source columns. Calculations are derived from other fields, and are either provided by your developer or created by you (see Calculations). They are computed at runtime rather than stored in the underlying data, so they update as the data changes. There are two types of calculations:
Calculated Columns - Non-aggregated calculations that return a value for each row. They are useful for transforming data (for example, cleaned labels), bucketing values (for example, a band), or computing flags based on logic.
Measures - Pre-aggregated calculations that compute values at the dataset level or per category. When a Measure is used without any grouping categories, it returns a single aggregated value for the entire dataset (for example, total revenue across all regions). When used with categories, it returns one value per category (for example, total revenue per region). Measures are intended for Metrics and KPIs and do not support changing aggregation at runtime.
Both are derived from other fields and computed at runtime. The difference is whether the value arrives already aggregated. A Calculated Column does not, so it behaves like any other column in a widget and you choose how to aggregate it. A Measure does, so it carries its own aggregation and none can be applied on top.
| Icon | Description |
|---|---|
| Number data types | |
| Calculated number data type |
In the example below, the table demonstrates a measure grouped by product. Line Net (sum) is an aggregated column calculated from order items. Gross Margin % is a measure that shows the aggregated margin percentage for each product.
import { Component } from "@angular/core";
import { AgStudio } from "ag-studio-angular";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getCalculationsData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
@Component({
selector: "my-app",
standalone: true,
imports: [AgStudio],
template: `<div style="display: flex; flex-direction: column; height: 100%">
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
[initialState]="initialState"
[mode]="mode"
[panels]="panels"
[data]="data"
/>
</div> `,
})
export class AppComponent {
initialState: AgReportState = {
pages: [
{
id: "page1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "products.product_name" },
{ id: "line_net", aggregation: "sum" },
{ id: "gross_margin_pct" },
],
},
format: {
title: {
enabled: true,
text: "Calculated Column and Measure by Product",
},
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 32,
},
},
},
],
selectedPageId: "page1",
};
mode: AgStudioMode = "edit";
panels: AgPanelConfig = {
edit: {
right: ["edit", "data"],
},
};
data: AgDataSourcesDefinition | AgDataEngine = getCalculationsData(
"https://www.ag-grid.com/studio/example-assets",
);
}

The Data panel organises the available data and shows how it is structured across sources.
AG Studio supports multiple data sources. This page explains how data is presented in the Data panel and how it is structured across sources. For how fields behave when used in widgets, see Using Data.
Data Panel Copy Link
The Data Panel lists the data available to the report, grouped by source. For an overview of how the Data Panel fits within the Studio interface, see User Interface.
The Data panel can be used to search for items by name. When a data pill is dragged, valid drop areas are highlighted in blue. Data pills can be dropped into widget configuration slots and Filter Conditions.
Select any data item to switch the Edit Panel to its data-field view, which displays metadata about that item.
Data Items Copy Link
Data items are fields made available in the Data Panel. A field is a data element that can be used in widgets and is one of three types: a column, a calculated column, or a measure.
- Columns are fields that come directly from the underlying data source and are typically used for categories (grouping) and, where appropriate, as values.
- Calculated Columns are fields derived from other data that return a value for each row.
- Measures are pre-aggregated calculations intended for Metrics and KPIs.
Each data item has the following properties:
| Property | Description |
|---|---|
| Id | The unique identifier for the data item. |
| Name | The display name shown in the interface. |
| Description | Additional supporting information about the data item. |
| Data Type | The type of data the item contains, such as text, number, date, or boolean. |
| Calculation Type | Whether the field is calculated: No Calculation for a column from the source, Calculation for a Calculated Column, or Measure for a Measure. |
| Format | How the value is displayed in the interface, for example as text, currency, percentage, or a date format. |
Select any field in the Data Panel to open its data-field view, which shows the metadata for that field, including its name, description, data type, calculation type, and format.
Id, Name, and Data Type are required and configured by your developer. Description and Format are optional and also configured by your developer.
Calculation Type reports which of the three kinds of field it is, and that is chosen when the field is created rather than worked out from the data. A field that comes from a data source is always a column, so it shows No Calculation. A calculation is either a Calculated Column or a Measure, and whoever creates it chooses which: your developer for the calculations you are given, you for the ones you add yourself (see Calculations).
The choice decides how the field can be used. A column or a Calculated Column holds a value for each row, so when you use one as a value in a widget you choose how to aggregate it. A Measure is already aggregated, so it brings its own aggregation and no other can be applied to it. See Using Data.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgFieldDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const salesFields: AgFieldDefinition[] = [
{
id: "sale_id",
name: "Sale ID",
format: "textFormat",
description: "Unique identifier for each sale transaction",
},
{
id: "date",
name: "Date",
format: "dateFormat",
description: "Date when the sale occurred",
},
{
id: "store_id",
name: "Store ID",
format: "textFormat",
description: "Identifier for the store where the sale took place",
},
{
id: "product_id",
name: "Product ID",
format: "textFormat",
description: "Identifier for the product sold",
},
{
id: "customer_id",
name: "Customer ID",
format: "textFormat",
description: "Identifier for the customer making the purchase",
},
{
id: "employee_id",
name: "Employee ID",
format: "textFormat",
description: "Identifier for the employee who processed the sale",
},
{
id: "quantity",
name: "Quantity",
format: "integerFormat",
description: "Number of units sold",
},
{
id: "unit_price",
name: "Unit Price",
format: "currencyFormat",
description: "Price per unit of the product",
formatOptions: {
format: "$#,##0.00",
},
},
{
id: "discount_pct",
name: "Discount Percentage",
format: "percentageFormat",
description: "Discount applied to the sale as a percentage",
formatOptions: {
format: "0.00%",
},
},
{
id: "amount",
name: "Amount",
format: "currencyFormat",
description: "Total sale amount after discounts",
formatOptions: {
format: "$#,##0.00",
},
},
{
id: "payment_method",
name: "Payment Method",
format: "textFormat",
description: "Method used for payment",
},
{
id: "status",
name: "Status",
format: "textFormat",
description: "Current status of the sale transaction",
},
{
id: "promo_id",
name: "Promo ID",
format: "textFormat",
description: "Identifier for any promotional offer applied",
},
];
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="display: flex; flex-direction: column; height: 100%">
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
@api-ready="onApiReady"
:initialState="initialState"
:mode="mode"
:panels="panels"
:data="data"></ag-studio>
</div>
</div>
`,
components: {
"ag-studio": AgStudio,
},
setup(props) {
const studioApi = shallowRef<AgStudioApi | null>(null);
const initialState = ref<AgReportState>({
pages: [
{
id: "a",
},
],
selectedPageId: "a",
});
const mode = ref<AgStudioMode>("edit");
const panels = ref<AgPanelConfig>({
edit: {
right: ["edit", "data"],
},
});
const data = ref<AgDataSourcesDefinition | AgDataEngine>({
sources: [
{
id: "sales",
name: "Sales",
fields: salesFields,
data: getData(),
},
],
});
const onApiReady = (params: AgStudioApiReadyEvent) => {
studioApi.value = params.api;
};
return {
studioApi,
initialState,
mode,
panels,
data,
onApiReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Data Source Copy Link
Data items shown in the Data Panel are grouped by data source. Reports can be powered by one data source or multiple data sources.
When the report uses a single data source, all fields and calculations come from the same source. Widgets can be configured without thinking about relationships.
When multiple data sources are used, every data item is listed under the source it comes from. A calculation is listed under a single source as well, even when its expression reads from more than one. A calculation you create stays in the section you created it in, whatever its expression later references. A calculation your developer provides is listed under the first source its expression reaches, whether it names that source itself or reaches it through another calculation it references. One that reaches no source at all is listed in a Computed Columns section at the end of the panel.
If relationships exist between data sources, data items can be combined across sources when Configuring Widgets. If no relationship exists between selected data, the interface prevents invalid combinations.
When you use data from multiple sources, you can create widgets that combine data items from different sources. In the example below, the table widget displays product names from the Products table along with order metrics from the Order Items table, including quantity, unit price, and net sales.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getMainDemoData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="display: flex; flex-direction: column; height: 100%">
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
@api-ready="onApiReady"
:initialState="initialState"
:mode="mode"
:panels="panels"
:data="data"></ag-studio>
</div>
</div>
`,
components: {
"ag-studio": AgStudio,
},
setup(props) {
const studioApi = shallowRef<AgStudioApi | null>(null);
const initialState = ref<AgReportState>({
pages: [
{
id: "page1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "products.product_name" },
{ id: "order_items.quantity", aggregation: "sum" },
{ id: "order_items.unit_price", aggregation: "avg" },
{ id: "net_sales" },
],
},
format: {
title: {
enabled: true,
text: "Sales by Product",
},
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 32,
},
},
},
],
selectedPageId: "page1",
});
const mode = ref<AgStudioMode>("edit");
const panels = ref<AgPanelConfig>({
edit: {
right: ["edit", "data"],
},
});
const data = ref<AgDataSourcesDefinition | AgDataEngine>(
getMainDemoData("https://www.ag-grid.com/studio/example-assets"),
);
const onApiReady = (params: AgStudioApiReadyEvent) => {
studioApi.value = params.api;
};
return {
studioApi,
initialState,
mode,
panels,
data,
onApiReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Calculated Fields Copy Link
Some fields in the Data panel are calculations rather than raw source columns. Calculations are derived from other fields, and are either provided by your developer or created by you (see Calculations). They are computed at runtime rather than stored in the underlying data, so they update as the data changes. There are two types of calculations:
Calculated Columns - Non-aggregated calculations that return a value for each row. They are useful for transforming data (for example, cleaned labels), bucketing values (for example, a band), or computing flags based on logic.
Measures - Pre-aggregated calculations that compute values at the dataset level or per category. When a Measure is used without any grouping categories, it returns a single aggregated value for the entire dataset (for example, total revenue across all regions). When used with categories, it returns one value per category (for example, total revenue per region). Measures are intended for Metrics and KPIs and do not support changing aggregation at runtime.
Both are derived from other fields and computed at runtime. The difference is whether the value arrives already aggregated. A Calculated Column does not, so it behaves like any other column in a widget and you choose how to aggregate it. A Measure does, so it carries its own aggregation and none can be applied on top.
| Icon | Description |
|---|---|
| Number data types | |
| Calculated number data type |
In the example below, the table demonstrates a measure grouped by product. Line Net (sum) is an aggregated column calculated from order items. Gross Margin % is a measure that shows the aggregated margin percentage for each product.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgStudio } from "ag-studio-vue3";
import {
AgDataEngine,
AgDataSourcesDefinition,
AgPanelConfig,
AgReportState,
AgStudioApi,
AgStudioApiReadyEvent,
AgStudioMode,
AgStudioProperties,
enableStudioDevValidations,
} from "ag-studio";
import { getCalculationsData } from "./data.ts";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableStudioDevValidations();
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div style="display: flex; flex-direction: column; height: 100%">
<ag-studio
style="width: 100%; height: 100%;"
class="my-studio-container"
@api-ready="onApiReady"
:initialState="initialState"
:mode="mode"
:panels="panels"
:data="data"></ag-studio>
</div>
</div>
`,
components: {
"ag-studio": AgStudio,
},
setup(props) {
const studioApi = shallowRef<AgStudioApi | null>(null);
const initialState = ref<AgReportState>({
pages: [
{
id: "page1",
widgets: {
"1": {
type: "grid",
dataMapping: {
cols: [
{ id: "products.product_name" },
{ id: "line_net", aggregation: "sum" },
{ id: "gross_margin_pct" },
],
},
format: {
title: {
enabled: true,
text: "Calculated Column and Measure by Product",
},
},
},
},
widgetLayout: {
"1": {
xTrack: 0,
yTrack: 0,
xSpan: 24,
ySpan: 32,
},
},
},
],
selectedPageId: "page1",
});
const mode = ref<AgStudioMode>("edit");
const panels = ref<AgPanelConfig>({
edit: {
right: ["edit", "data"],
},
});
const data = ref<AgDataSourcesDefinition | AgDataEngine>(
getCalculationsData("https://www.ag-grid.com/studio/example-assets"),
);
const onApiReady = (params: AgStudioApiReadyEvent) => {
studioApi.value = params.api;
};
return {
studioApi,
initialState,
mode,
panels,
data,
onApiReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");